/*
    Copyright (C) 2009  Subhrendu Sarkar

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef INCLUDE_INTERFACES_H
#define INCLUDE_INTERFACES_H

#include "common_defines.h"
#include <iostream>

/*
video Capture interface 
*/
class IVideoCapture
{
public :
	//gets the Video format supported
	virtual void getVideoFormat() = 0;
  //sets the video format to be supported
	virtual void setVideoFormat() = 0;
  //gets the video device properties e.g camera capture properties
	virtual void getVideoDeviceProp() = 0;
  //method to process the raw video; it encodes the captured media data 
	virtual void Process_Raw_Video(int buffers_ready,int PixFormat, int bufsize,int width, int height, unsigned char *data, int tsinc_usec) = 0;
	
	//prints the encoding frame rate 
	static void print_fps( )
	{

		static struct timeval next,current;
		static int count = 0;
		if( count == 0 )
		{
			gettimeofday(&next, NULL);
			next.tv_sec += 1;
		}

		count++;
	
		gettimeofday(&current, NULL);

		if( timercmp( &next, &current, <= ) )
		{
			printf( "FPS: %d\n", count );
			count = 0;
		}


		static struct timeval oldframe,currentframe;
		static int counter = 0;
		if(counter == 0)
		{
			gettimeofday(&oldframe, NULL);
		}
		counter++;
		gettimeofday(&currentframe, NULL);
		
	//	int p = (currentframe.tv_sec *1000 + currentframe.tv_usec) - (oldframe.tv_sec *1000 + oldframe.tv_usec);
//		if(p < 200)
//printf("Time diff : %d usecs\n",p );
		oldframe = currentframe;

	}	

};

// video encoder interface
class IVideoEnc
{
  //encodes a frame
	virtual void encode_frame() = 0;
  //converts the image format
	virtual void convert_img_format() = 0;
};



#endif


